#pragma once
#include <vector>
#include <stdio.h>  
#include <stdlib.h>  
#include "Structs.h"
#define M 10
#define N 10

#define STARTNODE   1  
#define ENDNODE     2  
#define BARRIER     3 
#define OBJSPACE    4
#define map_TILE_WIDTH 64.0f
#define COL_SIZE 75
#define ROW_SIZE 75
#define MAP_SIZE COL_SIZE * ROW_SIZE

class Sprite;
typedef struct _AStarNode
{
	int s_x;
	int s_y;
	int s_g;
	int s_h;
	int s_style;
	int s_objSpace = 0;
	struct _AStarNode * s_parent = nullptr;
	int s_is_in_closetable;
	int s_is_in_opentable;
	std::vector<Sprite*>occupants;
}AStarNode, *pAStarNode;
typedef std::vector<int>nodeList;
typedef std::vector<nodeList>mapList;


class AStar
{
public:
	AStar() {};
	AStar(int maze[M][N], int m, int n);
private:
	void swap(int idx1, int idx2);
	void adjust_heap(int nIndex);
	void insert_to_opentable(int x, int y, pAStarNode curr_node, pAStarNode end_node, int w);
	void get_neighbors(pAStarNode curr_node, pAStarNode end_node);
public:
	void Init(mapList& map);
	void Reset();
	std::vector<Vec2i> findPath(Vec2i start, Vec2i end);
	std::vector<Vec2i> getPossiblePlacements(Vec2i pos, int group_size);
	pAStarNode getMapNode(int x, int y) { return &map_maze[y][x]; }
	
	pAStarNode getNode(Vec2i pos) { return &map_maze[pos.y][pos.x]; }
	

private:
	AStarNode  map_maze[100][100];
	pAStarNode open_table[MAP_SIZE];
	pAStarNode close_table[MAP_SIZE];
	int   open_node_count;
	int    close_node_count;
	pAStarNode path_stack[MAP_SIZE];
	int        top = -1;

	AStarNode *start_node;
	AStarNode *end_node;

	std::vector<Vec2i> pathPositions;
};