#pragma once

#include "Ball.h"

class PlayingField
{
	std::vector<Block> m_grid;
	int m_width;
	int m_height;
	int m_rows;
	int m_columns;
	int m_numbBlocks = 0;
	bool m_hitBottom;
	Vec4f m_size;
	Vec2i m_cellSize;
	Color m_fillColor;
	Color m_borderColor;
public:
	PlayingField();
	
	Block* GetCell(Vec2i pos);
	void Initialize(std::vector<std::string> level_data,Vec4f frame, Vec2i cellSize, Color fillColor, Color borderColor);
	void DrawFilled(class Graphics& gfx);
	void DrawBordered(class Graphics& gfx);
	void DrawFilledBordered(class Graphics& gfx);
	void DrawCellsBorder(class Graphics& gfx);
	void DrawCellsFilled(class Graphics& gfx);
	void DrawCellsFilledBorder(class Graphics& gfx);
	void ConfineAndRebound(Vec4f& sq,Vec2f& vel);
	bool DoCollision(Ball* obj);
	bool BlocksStillRemaining();
	bool HitBottom();
};