#pragma once
#include "Structs.h"
#include "Colors.h"
class Block
{
protected:
	Vec4f m_pos;
	Vec2f m_vel;
	bool m_visible = false;
	Color m_fillColor;
	Color m_borderColor;
	
public:
	Block();
	virtual ~Block() {}
	Block(Vec4f size, Color fillcolor,Color border);
	virtual void Update() {};
	bool IsVisible();
	void SetVisible(const bool val);
	Vec4f* GetDimension();
	void SetFillColor(Color c);
	Color GetColor();
	Vec2i GetCenter();
	float Width();
	float Height();
	bool Collision(Block& other,Vec2f& vel);
	void DrawFilled(class Graphics& gfx);
	void DrawBordered(class Graphics& gfx);
	
};