
#include "Paddle.h"

void Paddle::ConfineBallToPaddle()
{
	// if no ball captured, exit function
	if (!m_capturedBall)
		return;

	Vec4f& ballDim = *m_capturedBall->GetDimension();
	float w = (ballDim.right - ballDim.left);
	if (ballDim.left < m_pos.left)
	{
		ballDim.left = m_pos.left;
		ballDim.right = ballDim.left + w;

	}
	if (ballDim.right > m_pos.right)
	{
		ballDim.left = m_pos.right - w;
		ballDim.right = ballDim.left  + w;

	}

	

}

Paddle::Paddle(Vec4f size, Color fillColor, Color borderColor)
	:
	Ball(size,fillColor,borderColor)
{
	m_isObjectCaptured = false;
}

Vec2f Paddle::ReleaseBall()
{
	if (m_isObjectCaptured)
	{
		Vec2f pos1 = Vec2f((float)GetCenter().x, (float)GetCenter().y);
		Vec2f pos2 = Vec2f((float)m_capturedBall->GetCenter().x,
			(float)m_capturedBall->GetCenter().y);
		Vec2f dir = pos2 - pos1;
		dir.Normalize();
		m_capturedBall->SetVelocity(dir);
		m_capturedBall = nullptr;
		m_isObjectCaptured = false;
		return dir;
	}
	return Vec2f();
}

void Paddle::CaptureBall(Ball * ball)
{
	int c = 0;
	if (!m_isObjectCaptured)
	{
		Vec2f v = ball->Velocity();
		if (Collision(*ball,v))
		{
			m_isObjectCaptured = true;
			ball->GetDimension()->bottom = this->m_pos.top;
			ball->GetDimension()->top = ball->GetDimension()->bottom - ball->Height();
			ball->SetVelocity(Vec2f(0.0f, 0.0f));
			m_capturedBall = ball;
		}
	}
}

void Paddle::Update()
{
	
	m_pos.left  += m_vel.x* m_speed;
	m_pos.right += m_vel.x* m_speed;
	
	if (m_isObjectCaptured)
	{
		ConfineBallToPaddle();
	}
}
bool Paddle::BallCaptured()
{ 
	return m_isObjectCaptured;
}
